<?php
/**
* @version 			SEBLOD 3.x Core
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

// No Direct Access
defined( '_JEXEC' ) or die;

// Plugin
class plgCCK_FieldJoinn2n extends JCckPluginField
{
	protected static $type		=	'joinn2n';
	protected static $path;
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Construct
	
	// onCCK_FieldConstruct
	public function onCCK_FieldConstruct( $type, &$data = array() )
	{
		if ( self::$type != $type ) {
			return;
		}
		parent::g_onCCK_FieldConstruct( $data );
	}
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Prepare
	
	// onCCK_FieldPrepareContent
	public function onCCK_FieldPrepareContent( &$field, $value = '', &$config = array() )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		parent::g_onCCK_FieldPrepareContent( $field, $config );
		
		// Init
		$options2	=	JCckDev::fromJSON( $field->options2 );
		$divider	=	'';
		$lang_code	=	'';
		$value2		=	'';
		
		/* tmp */
		$jtext						=	$config['doTranslation'];
		$config['doTranslation']	=	0;
		/* tmp */
		
		// Prepare
		self::_languageDetection( $lang_code, $value2, $options2 );
		if ( $field->bool3 ) {
			$divider	=	( $field->divider != '' ) ? $field->divider : ',';
		}
		
		if ( $field->location ) {
			$attribs	=	explode( '||', $field->location );
			$attrib		=	count( $attribs );
		} else {
			$attribs	=	array();
			$attrib		=	0;
		}
		
		if(!empty($value)){
			// get query AND label and attr from the query o/
			$query = $this->getQuery($field, $value);
			// 			$pattern = "#(\w*)(?:[{\s}*]as[{\s}*]value[{\s|,}*])#";
			$pattern = "#([^\s&&^,]*)(?:[{\s}*]as[{\s}*]value[{\s|,}*])#";
		
			$matches = array();
			$r = preg_match($pattern, $query,$matches);
			// TODO check if not better to do a LIKE depending of the dataType , for now let's add quote systematically >__<
			
			$where = 'where '.$matches[1].' = "'.$value. '"';			
		
			$query = substr_replace($query, $where, strpos($query, 'where'));
			$db = JFactory::getDbo();
			$db->setQuery($query);
			$res = $db->loadObject();			
			$field->text = $res->text;
		}
		// Set
		$field->value		=	$value;
		$field->typo_target	=	'text';
		
	}
	
	// onCCK_FieldPrepareForm
	public function onCCK_FieldPrepareForm( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		self::$path	=	parent::g_getPath( self::$type.'/' );
		parent::g_onCCK_FieldPrepareForm( $field, $config );
		
		// Init
		if ( count( $inherit ) ) {
			$id		=	( @$inherit['id'] != '' ) ? $inherit['id'] : $field->name;
			$name	=	( @$inherit['name'] != '' ) ? $inherit['name'] : $field->name;
		} else {
			$id		=	$field->name;
			$name	=	$field->name;
		}
		
		// Validate
		$validate	=	'';
		if ( $config['doValidation'] > 1 ) {
			plgCCK_Field_ValidationRequired::onCCK_Field_ValidationPrepareForm( $field, $id, $config );
			parent::g_onCCK_FieldPrepareForm_Validation( $field, $id, $config );
			
			$validate	=	( count( $field->validate ) ) ? ' validate['.implode( ',', $field->validate ).']' : '';
		}
		
		// Prepare
		$class	=	'inputbox text'.$validate.' '.$field->css;
		$maxlen	=	( $field->maxlength > 0 ) ? 'maxlength="'.$field->maxlength.'" ' : '';
		$size	=	'size="'.$field->size.'" ';
		$style	=	( @$field->style ) ? 'style="'.$field->style.'" ' : '';
		
		$form = '';
// 		$form	=	'<input type="text" id="label_'.$id.'" class="label_joinn2n_'.$field->id.'" name="label_'.$name.'" value="" />';
		
		
		$options2	=	JCckDev::fromJSON( $field->options2 );
		
		
		if($config['type'] == $options2['content_type_linked1']){
			$othertype = $options2['content_type_linked2'];
			$otherFieldLinking = $options2['field_linking2'];
			$thisFieldLinking  = $options2['field_linking1'];
		}elseif($config['type'] == $options2['content_type_linked2']){
			$othertype = $options2['content_type_linked1'];
			$otherFieldLinking = $options2['field_linking1'];
			$thisFieldLinking  = $options2['field_linking2'];
		}else{
			return;
		}

		$typeLinking = $options2['content_type_linking'];
		
		// get field
		$db = JFactory::getDbo();
		$query = 'SELECT  t.* FROM #__cck_core_types AS t WHERE name LIKE "'.$othertype.'"';
		$db->setQuery($query);
		$otherTypeObject = $db->loadObject();
		if(empty($otherTypeObject))
			throw new Exception("Le type de contenu $othertype n'existe pas");
		
		$query = 'SELECT  f.* FROM #__cck_core_fields AS f WHERE id = '.$otherFieldLinking;
		$db->setQuery($query);
		$otherFieldLinkingObject = $db->loadObject();
		if(empty($otherFieldLinkingObject))
			throw new Exception("Le champ $otherFieldLinking n'existe pas");
		
		$query = 'SELECT  f.* FROM #__cck_core_fields AS f WHERE id = '.$thisFieldLinking;
		$db->setQuery($query);
		$thisFieldLinkingObject = $db->loadObject();
		if(empty($thisFieldLinkingObject))
			throw new Exception("Le champ $thisFieldLinking n'existe pas");
		
		
		// get title if content OR name if user, depending storage_location
		$fieldLabel = $tablejoin = '';
		switch($otherTypeObject->storage_location){
			case 'joomla_article':
				$fieldLabel = 'title';
				$tablejoin = '#__content';
				break;
			case 'joomla_user':
				$fieldLabel = 'name';
				$tablejoin = '#__users';
				break;
		}
	
		$tmp = CCK_Form::getFields(array($typeLinking,''),'admin',-1,'',true,true);
		$f_Linking = array();
		$query_add_fields = '';

		foreach($tmp as $f){
			if($f->storage_table == $thisFieldLinkingObject->storage_table && !in_array($f->id,array($thisFieldLinkingObject->id,$otherFieldLinkingObject->id))){
				$f_Linking[] = $f;
				$query_add_fields .= ', linkingTable.'.$f->storage_field.' AS '.$f->name.' ';
			}
		}	


		$query = 'SELECT core.pk AS value, tjoin.'.$fieldLabel.' AS text ';
$query .= ',  linkingTable.'.$thisFieldLinkingObject->name.' AS testet ';
		$query .= ( (!$config['isNew'] && isset($config['pk']) )  ?  (', REPLACE( GROUP_CONCAT( CASE WHEN linkingTable.'.$thisFieldLinkingObject->name.' = '.$config['pk'].' THEN 1 ELSE 0 END) , ",","" ) AS linked ') : '');
		$query .= ' ,linkingTable.id AS linkingValue  ';
		$query .= $query_add_fields;
		$query .= ' FROM '.$thisFieldLinkingObject->storage_table.' AS linkingTable RIGHT JOIN #__cck_core AS core ON ( linkingTable.'.$otherFieldLinkingObject->name.' = core.pk  ';
		$query .= ' AND ( linkingTable.'.$thisFieldLinkingObject->name.' IS NULL OR linkingTable.'.$thisFieldLinkingObject->name.' = '.$config['pk'].') ';
		$query .= ' ) ';
		$query .= ' INNER JOIN '.$tablejoin.' AS tjoin ON ( tjoin.id = core.pk ) WHERE core.cck LIKE "'.$othertype.'" ';

		$query .= ' GROUP BY tjoin.id';//,  linkingTable.'.$thisFieldLinkingObject->name;

// echo $query;die();	
		$db->setQuery($query);
		$records = $db->loadObjectList();
//var_dump($records);die();

		$ids_linking = array();
		$html = '';

		$typeLinkingObject	=	CCK_Form::getType( $typeLinking );

		foreach($records as $record){

			$linked = (boolean)(int)$record->linked;
			$html .= '<div class="linkingRecord">';
			$html .= '<input class="linkingField" type="checkbox" name="" value="'.$record->value.'" ';
			if($linked){
				$ids_linking[$record->value] = array();
				$html .= ' checked ';
			}
			$html .= ' >'.$record->text.'<br>';
			
			$htmlFields = '<div class="additionalMapFields '. ( ($linked) ? 'linked' : 'unlinked') .'">';
			foreach($f_Linking as $f){
				self::_getField($f,$typeLinkingObject, is_null($record->linkingValue) ? 0 : $record->linkingValue ,$config);
				$htmlFields .= $f->label.' '. $f->form;
				if($linked){
					$ids_linking[$record->value][$f->name] = $f->value;
				}
			}
			$htmlFields .='</div>';
			$html .= $htmlFields;
			$html .= '</div><br>';
		}
		//$ids_linking = implode(',',$ids_linking);
		$ids_linking = count($ids_linking) ? json_encode($ids_linking,true) : '{}';
		$form	.=	"<input type='text' style='display: none;' class='joinn2n_".$field->id." real_value_joinn2n' id='".$id."' name='".$name."' value='".$ids_linking."' />";
		$form .= $html;
		
		if ( ! $field->variation ) {
			$field->form	=	$form;
			if ( $field->script ) {
				parent::g_addScriptDeclaration( $field->script );
			}
		} else {
			parent::g_getDisplayVariation( $field, $field->variation, $value, $value, $form, $id, $name, '<input' );
		}
		$field->value	=	$value;
		
		$app = JFactory::getApplication();
		$doc =JFactory::getDocument();
		$script = self::$path.'assets/js/';
		
		if(empty($doc->_scripts[$script."script.js"])){
                        $doc->addScript($script."script.js");
                }
	
		if($app->isAdmin()){	
			$script .= 'script_back.js';
		}elseif($app->isSite()){
			$script .= 'script_front.js';
		}
		if(empty($doc->_scripts[$script])){
			$doc->addScript($script);
		}
//		$doc->addScriptDeclaration($script);
		// Return
		if ( $return === true ) {
			return $field;
		}
	}
	
	// onCCK_FieldPrepareSearch
	public function onCCK_FieldPrepareSearch( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}
		
		// Prepare
		self::onCCK_FieldPrepareForm( $field, $value, $config, $inherit, $return );
		
		// Return
		if ( $return === true ) {
			return $field;
		}
	}
	
	// onCCK_FieldPrepareStore
	public function onCCK_FieldPrepareStore( &$field, $value = '', &$config = array(), $inherit = array(), $return = false )
	{
		if ( self::$type != $field->type ) {
			return;
		}

//var_dump($value);die();
		// Init
		if ( count( $inherit ) ) {
			$name	=	( @$inherit['name'] != '' ) ? $inherit['name'] : $field->name;
		} else {
			$name	=	$field->name;
		}
		
	
		// HERE, with the value, we create data
		$options2	=	JCckDev::fromJSON( $field->options2 );
		
		if($config['type'] == $options2['content_type_linked1']){
			$othertype = $options2['content_type_linked2'];
			$otherFieldLinking = $options2['field_linking2'];
			$thisFieldLinking  = $options2['field_linking1'];
		}elseif($config['type'] == $options2['content_type_linked2']){
			$othertype = $options2['content_type_linked1'];
			$otherFieldLinking = $options2['field_linking1'];
			$thisFieldLinking  = $options2['field_linking2'];
		}else{
			return;
		}
		
		$typeLinking = $options2['content_type_linking'];
		$linkingcategory =  $options2['linkingcategory'];
		parent::g_addProcess( 'afterStore', self::$type, $config, array( 'name'=>$name, 'value'=>$value, 'othertype'=>$othertype, 'otherFieldLinking'=>$otherFieldLinking,'thisFieldLinking'=>$thisFieldLinking,'typeLinking'=>$typeLinking,'linkingCategory'=>$linkingcategory) );
		
		// Validate
		parent::g_onCCK_FieldPrepareStore_Validation( $field, $name, $value, $config );
		
		// Set or Return
		if ( $return === true ) {
			return $value;
		}
		$field->value	=	$value;
		parent::g_onCCK_FieldPrepareStore( $field, $name, $value, $config );
	}
	
	// -------- -------- -------- -------- -------- -------- -------- -------- // Render
	
	// onCCK_FieldRenderContent
	public static function onCCK_FieldRenderContent( $field, &$config = array() )
	{
		$ret = parent::g_onCCK_FieldRenderContent( $field, 'text' );

		return $ret;
	}
	
	// onCCK_FieldRenderForm
	public static function onCCK_FieldRenderForm( $field, &$config = array() )
	{
		// TODO clean this to check ALL jquery-ui and not only this specifiq path
		// a bit ugly, i've got to admit, but still working for now
		$doc    =       JFactory::getDocument();
		$path = '/media/cck/js/jquery.ui.min.js';
		$newPath = self::$path.'assets/js/jquery-ui.js';
		if( !isset($doc->_scripts[$path]) && !isset($doc->_scripts[str_replace('//', '\\', $path)]) && !isset($doc->_scripts[$newPath])){
			$doc->addScript($newPath);
		}
		return parent::g_onCCK_FieldRenderForm( $field );
	}
	
	
	// onCCK_FieldAfterStore
	public static function onCCK_FieldAfterStore( $process, &$fields, &$storages, &$config = array() )
	{
		
		// here we've to create contents for linking
		
		// $othertype
		$othertype		=	$process['othertype'];
		$typeLinking	=	$process['typeLinking'];
		$otherFieldLinking	=	$process['otherFieldLinking'];
 		$thisFieldLinking	=	$process['thisFieldLinking'];
		$linkingCategory	=	$process['linkingCategory'];

// 		$storage_location_linking	=	$process['storage_location_linking'];
// 		'othertype'=>, 'fieldLinking1'=>$fieldLinking1,'fieldLinking2'=>$fieldLinking2,'typeLinking'=>$typeLinking ) );
		
		// get field
		$db = JFactory::getDbo();
		$query = 'SELECT  t.* FROM #__cck_core_types AS t WHERE name LIKE "'.$typeLinking.'"';
		$db->setQuery($query);
		$typeLinkingObject = $db->loadObject();
		if(empty($typeLinkingObject))
			throw new Exception("Le type de contenu $typeLinking n'existe pas");
		
		if($typeLinkingObject->storage_location != 'joomla_article')
			throw new Exception("Le type de contenu de liaison ne peut tre qu'un champ avec un storage_location de type joomla_article");
		
		$tableLinking = '';
		$query = 'SELECT f.* FROM #__cck_core_fields AS f WHERE id = '.$otherFieldLinking;
		$db->setQuery($query);
		$otherFieldLinking = $db->loadObject();
		
		$query = 'SELECT f.* FROM #__cck_core_fields AS f WHERE id = '.$thisFieldLinking;
		$db->setQuery($query);
		$thisFieldLinking = $db->loadObject();
		
		
		$value = $process['value'];
		$objectsMap = json_decode($value,true);
		$idsLink = array_keys($objectsMap);
		//$idsLink = empty($value) ? array() : explode(',', $value);
		
		$tableMap = $otherFieldLinking->storage_table;

		$fieldLabel = $tablejoin = '';
		$fieldLabel = 'title';
		$tablejoin = '#__content';
		$validatorField	=	'state';
		$validatorValue	=	'1';
		
		$groups = array(8);
	
		// delete all records from join table not in idsLink
		$query = 'DELETE  linkingtable, core, tjoin ';
		$query .= ' FROM '.$tableMap. ' AS linkingtable INNER JOIN #__cck_core AS core ON core.pk = linkingtable.id';
		$query .= ' INNER JOIN '.$tablejoin.' AS tjoin ON ( tjoin.id = core.pk AND core.cck LIKE "'.$typeLinking .'" )';
		$query .= ' WHERE linkingtable.'.$thisFieldLinking->name.' = '.$config['pk'];
		$query .= count($idsLink) ? ( ' AND linkingtable.'.$otherFieldLinking->name.' NOT IN ('.implode(',', $idsLink).')' ) : '';
		$db->setQuery($query);
		$db->execute();
	
		$query = 'SELECT GROUP_CONCAT( linkingtable.'.$otherFieldLinking->name.' ORDER BY linkingtable.'.$otherFieldLinking->name.' ASC) AS value FROM '.$tableMap.' AS linkingtable INNER JOIN #__cck_core AS core ON (core.pk = linkingtable.id AND core.cck LIKE "'.$typeLinking.'" AND linkingtable.'.$thisFieldLinking->name.' = '.$config['pk'].' ) ';		
		$db->setQuery($query);
		$existingids = $db->loadResult();
		$existingids = explode(',', $existingids);
		$ids_to_create = array_diff($idsLink, $existingids);
		$ids_to_update = array_diff($idsLink, $ids_to_create);


/*		
		if(!count($ids_to_create))
			return;
*/
		$query = 'SELECT storage_location FROM #__cck_core_types WHERE  name LIKE "'. $othertype .'"';
		$db->setQuery($query);
		$otherstorage = $db->loadResult();
		
		$fieldLabelLinked = $tablejoinLinked = '';
		switch($otherstorage){
			case 'joomla_article':
				$fieldLabelLinked = 'title';
				$tablejoinLinked = '#__content';
				break;
			case 'joomla_user':
				$fieldLabelLinked = 'name';
				$tablejoinLinked = '#__users';
				break;
		}

		if(count($ids_to_create)){
			$query = 'SELECT id AS value, '. $fieldLabelLinked. ' AS text FROM '.$tablejoinLinked.' WHERE id IN ('.implode(',',$ids_to_create).')';
			$db->setQuery($query);
			$ids_to_create = $db->loadObjectList();
		
			$query = 'SELECT '. ( isset($storages['#__content']) ? 'title' : '' ) . ( isset($storages['#__users']) ? 'name' : '' ) . ' FROM ';
			$query .= ( isset($storages['#__content']) ? '#__content' : '' ) . ( isset($storages['#__users']) ? '#__users' : '' )  ;
			$query .= ' WHERE id ='.$config['pk'];
			$db->setQuery($query);
			$thistitle = $db->loadResult();
		
			// get all already existing ids
			foreach($ids_to_create as $idToCreate){
		
				$title = 'liaison '.$config["type"].' '.$thistitle. ' '.$othertype.' '.$idToCreate->text;
				$alias = JApplication::stringURLSafe($title);
				$user = JFactory::getUser();
				$date = date('Y-m-d H:i:s');

				$dataContent = array(
					$fieldLabel=>$title,
					'alias'	=>	$alias,
					$validatorField => $validatorValue,
					'catid'	=>	$linkingCategory,
					'created_by'	=>	$user->id,
					'created'	=>	$date,
					'language'	=>	'*'
				);

				$content = JCckTable::getInstance($tablejoin,'id');
				$content->bind($dataContent);
				$content->store();
			
				$core = JCckTable::getInstance( '#__cck_core', 'id' );
				$core->bind( array(
					'cck'=>$typeLinking, // example using the content type called 'article',
					'pk'=>$content->id,
					'storage_location'=>'joomla_article',
					'author_id'=>$user->id,
					'parent_id'=>0,
					'date_time'=>JFactory::getDate()->toSql()
				) );
				$core->store();
			
				$content->introtext = "::cck::".$core->id."::/cck::";
				$content->store();
			
				$sqlAddMapName = $sqlAddMapValue = "";
				if(!empty($objectsMap[$idToCreate->value])){
					foreach($objectsMap[$idToCreate->value] as $fieldAddName => $fieldAddValue){
						$sqlAddMapName .= ", $fieldAddName ";
						$sqlAddMapValue .= ",'$fieldAddValue' ";
					}
				}
				$sql = "INSERT INTO ".$tableMap." (id,".$thisFieldLinking->name.",".$otherFieldLinking->name;
				$sql .= $sqlAddMapName;
				$sql .= ") VALUES(".$content->id.",".$config['pk'].",$idToCreate->value ";
				$sql .= $sqlAddMapValue;
				$sql .= ")";
				$db->setQuery($sql);
				$db->execute();
			
			}
		}
		if(count($ids_to_update)){
			foreach($ids_to_update as $toUp){

				if(empty($objectsMap[$toUp]))
					continue;
				$query = 'SELECT id FROM '.$tableMap.' WHERE '.$otherFieldLinking->name.' = '.$toUp.' AND '.$thisFieldLinking->name.' = '.$config['pk'];
				$db->setQuery($query);
				$res = $db->loadResult();

				if(empty($res)){
					return false;
				}
				$table = JCckTable::getInstance($tableMap,'id');
				$table->load($res);

				foreach($objectsMap[$toUp] as $fname => $fval){
					$table->$fname = $fval;
				}
				$res = $table->store();
/*
if($toUp == 21){
var_dump($res);die();
var_dump($table);die();
var_dump($objectsMap[$toUp]);die();
}
*/
			}
		}
	}	
	
	
	// _languageDetection
	protected static function _languageDetection( &$lang_code, &$value, $options2 )
	{
		if ( @$options2['geoip'] && function_exists( 'geoip_country_code_by_name' ) ) {
			$lang_code	=	geoip_country_code_by_name( $_SERVER['REMOTE_ADDR'] );
		} else {
			jimport( 'joomla.language.helper' );
			$languages	=	JLanguageHelper::getLanguages( 'lang_code' );
			$lang_tag	=	JFactory::getLanguage()->getTag();
			$lang_code	=	( isset( $languages[$lang_tag] ) ) ? strtoupper( $languages[$lang_tag]->sef ) : '';
		}
		$value			=	str_replace( '[lang]', $lang_code, $value );
		$languages		=	explode( ',', @$options2['language_codes'] );
		if ( ! in_array( $lang_code, $languages ) ) {
			$lang_code	=	@$options2['language_default'] ? $options2['language_default'] : '';
		}
		$lang_code		=	strtolower( $lang_code );
	}

	protected static function _getField(&$field,$type,$id){
	
		$current = JURI::current();
		$config =       array( 'action'=>"",
                                   'asset'=>'com_content',
                                   'asset_id'=>0,
                                   'author'=>0,
                                   'client'=>'admin',
                                   'core'=>true,
                                   'custom'=>'',
                                   'doTranslation'=>JCck::getConfig_Param( 'language_jtext', 0 ),
                                   'doValidation'=>JCck::getConfig_Param( 'validation', '2' ),
                                   'error'=>false,
                                   'fields'=>array(),
                                   'formId'=> "seblod_form",
                                   'isNew'=> ( $id > 0),
                                   'javascript'=>'',
                                   'pk'=>$id,
                                   'submit'=>"JCck.Core.submit",
                                   'storages'=>array(),
                                   'translate_id'=>0,
                                   'type'=>$type->name,
                                   'type_id'=>$type->id,
                                   'url'=> $current ,
                                   'validate'=>array(),
                                   'validation'=>array(),
                                   'validation_options'=>array()
                                );

		$dispatcher	=	JDispatcher::getInstance();
		$name	=	$field->name;
		$value	=	'';
	
		// Prepare
		if ( $retry == $type->name ) {
			$value	=	( isset( $post[$name] ) ) ? $post[$name] : '';
		} else {
			if ( $id ) {
				$Pt	=	$field->storage_table;
				if ( $Pt && ! isset( $config['storages'][$Pt] ) ) {
					$config['storages'][$Pt]	=	'';
					$dispatcher->trigger( 'onCCK_Storage_LocationPrepareForm', array( &$field, &$config['storages'][$Pt], $id, &$config ) );
					if ( !isset( $config['base'] ) ) {
						$config['base']				=	new stdClass;
						$config['base']->location	=	$field->storage_location;
						$config['base']->table		=	$Pt;
					}
				}
				$dispatcher->trigger( 'onCCK_StoragePrepareForm', array( &$field, &$value, &$config['storages'][$Pt], &$config ) );
			} else {
				if ( $field->live ) {
					$dispatcher->trigger( 'onCCK_Field_LivePrepareForm', array( &$field, &$value, &$config ) );
					$hash		=	JApplication::getHash( $value );
					$session->set( 'cck_hash_live_'.$field->name, $hash );
				} else {
					$value	=	( isset( $lives[$name] ) ) ? $lives[$name] : $field->live_value;
				}
			}

		}
		$field->value	=	$value;
		$dispatcher->trigger( 'onCCK_FieldPrepareForm', array( &$field, $value, &$config, array() ) );
	}
}
?>
